
entity = {}
math.random = love.math.random --Using the LÖVE math module is recommended 
timesfallen = 0

entity.new = function(t)
	table.insert(entity, {x = math.random(20, love.window.getWidth()), y = 0, t = t})
end
	
entity.draw = function()
	for k, v in ipairs(entity) do
		if v.t == "coin" then
			love.graphics.setColor(255, 255, 0)
			love.graphics.rectangle("fill", v.x, v.y, 14, 14)
		elseif v.t == "enemy" then
			love.graphics.setColor(200, 60, 60)
			love.graphics.rectangle("fill", v.x, v.y, 14, 14)
		elseif v.t == "life" then
			love.graphics.setColor(0, 130, 255) --Life should be the same color of the player
			love.graphics.rectangle("fill", v.x, v.y, 14, 14)
		elseif v.t == "boost" then
			love.graphics.setColor(222, 63, 142)
			love.graphics.rectangle("fill", v.x, v.y, 14, 14)
		end
	end
end
	
entity.update = function(dt)
	for k, v in ipairs(entity) do
		v.y = v.y + 180 * dt
		if v.y >= 320 then
			v.y = 0
			if v.t ~= "life" then
				if v.t ~= "boost" then
					v.x = math.random(20, love.window.getWidth())
				elseif v.t == "boost" then
					if timesfallen ~= 15 then
						v.x = -90
						timesfallen = timesfallen + 1
					else
						v.x = math.random(20, love.window.getWidth())
						timesfallen = 0
					end
				end
			elseif v.t == "life" then
				if timesfallen ~= 15 then
					v.x = -90
					timesfallen = timesfallen + 1
				else
					v.x = math.random(20, love.window.getWidth())
					timesfallen = 0
				end
			end
		end
		if checkCollision(v.x, v.y, 15, 15, player.x, player.y, 20, 20) and v.t == "coin" then
			game.score = game.score + 1
			game.fakescore = game.fakescore + 1
			if game.sfx then
				love.audio.newSource("game/sound/coin.wav"):play()
			end
			v.y = 0
			v.x = math.random(20, love.window.getWidth())
		elseif checkCollision(v.x, v.y, 15, 15, player.x, player.y, 20, 20) and v.t == "enemy" then
			player.life = player.life - 1
			if game.sfx then
				love.audio.newSource("game/sound/hurt.wav"):play()
			end
			v.y = 0
			v.x = math.random(20, love.window.getWidth())
		elseif checkCollision(v.x, v.y, 15, 15, player.x, player.y, 20, 20) and v.t == "life" then
			if player.life ~= 3 then
				player.life = player.life + 1
			end
			if game.sfx then
				love.audio.newSource("game/sound/1up.wav"):play()
			end
			v.y = 0
			if timesfallen ~= 15 then
				v.x = -90
				timesfallen = timesfallen + 1
			else
				v.x = math.random(20, love.window.getWidth())
				timesfallen = 0
			end
		elseif checkCollision(v.x, v.y, 15, 15, player.x, player.y, 20, 20) and v.t == "boost" then
			if player.speed == 130 then
				player.speed = 180
			end
			if game.sfx then
				love.audio.newSource("game/sound/1up.wav"):play()
			end
			v.y = 0
			if timesfallen ~= 15 then
				v.x = -90
				timesfallen = timesfallen + 1
			else
				v.x = math.random(20, love.window.getWidth())
				timesfallen = 0
			end
		end
	end
end