
menu = require 'mylib.menu'
require 'game.player'
require 'game.entity'

game = {}
cloud = {}
cloud.x = -90
cloud.y = 100

game.load = function()
	useless1, useless2, flags = love.window.getMode()
	menu1 = menu.new()
	optionmenu = menu.new()
	gameovermenu = menu.new()
	menu1:addItem {
		name = "play squares",
		action = function() gamestate = "game" end
		}
	menu1:addItem {
		name = "options",
		action = function() gamestate = "options" end
		}
	menu1:addItem {
		name = "quit squares",
		action = function() love.event.quit() end
		}
	optionmenu:addItem {
		name = "vsync: off",
		action = function(self)
			if flags.vsync == false then
				love.window.setMode(422.5, 450, {vsync = true})
				self.name = "vsync: on"
				useless1, useless2, flags = love.window.getMode()
			elseif flags.vsync == true then
				love.window.setMode(422.5, 450, {vsync = false})
				self.name = "vsync: off"
				useless1, useless2, flags = love.window.getMode()
			end
		end	
		}
	gameovermenu:addItem {
		name = "back to main menu",
		action = function() gamestate = "menu" end
		}
	gameovermenu:addItem {
		name = "quit squares",
		action = function() love.event.quit() end
		}
	optionmenu:addItem {
		name = "music: on",
		action = function(self)
			if game.music then
				game.music = false
				self.name = "music: off"
			elseif not game.music then
				game.music = true
				self.name = "music: on"
			end
		end
		}
	optionmenu:addItem {
		name = "sfx: on",
		action = function(self)
			if game.sfx then
				game.sfx = false
				self.name = "sfx: off"
			elseif not game.sfx then
				game.sfx = true
				self.name = "sfx: on"
			end
		end
		}
	optionmenu:addItem {
		name = "back to main menu",
		action = function() gamestate = "menu" end
		}
	entity.new("coin")
	entity.new("enemy")
	love.graphics.setBackgroundColor(95, 255, 255)
	game.score = 0
	game.music = true
	game.sfx = true
	game.fakescore = 0
	menuloop = love.audio.newSource("game/music/menuloop.mp3")
	gameloop = love.audio.newSource("game/music/gameloop.mp3")
	fontN = love.graphics.newFont("game/font/coders_crux.ttf", 32)
	fontT = love.graphics.newFont("game/font/coders_crux.ttf", 48)
	menuloop:setLooping(true)
	gameloop:setLooping(true)
	gamestate = "menu"
end
	
game.draw = function()
	if gamestate == "menu" then
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontT)
		love.graphics.print("squares", love.window.getWidth()/2 - 65, 100)
		love.graphics.setFont(fontN)
		love.graphics.print("version "..VERSION, love.window.getWidth()/2 - 65, 130)
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(255, 255, 255)
		menu1:draw(60, 240)
	elseif gamestate == "game" then
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(255, 255, 0)
		love.graphics.rectangle("fill", 183, 370, 20, 20) --I think that the square the same color as the coin is easier to understan
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontN)
		love.graphics.print("x" .. game.score, 213, 370) --When I first played I didnt know what to catch and I died
		love.graphics.rectangle("fill", cloud.x, cloud.y, 100, 50)
		player.draw()
		entity.draw()
	elseif gamestate == "gameover" then
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontT)
		love.graphics.print("game over!",love.window.getWidth()/2 - 85, 100)
		love.graphics.setFont(fontN)
		gameovermenu:draw(60, 240)
	elseif gamestate == "options" then
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontT)
		love.graphics.print("options", love.window.getWidth()/2 - 65, 100)
		love.graphics.setFont(fontN)
		optionmenu:draw(60, 220)
	end
end
	
game.update = function(dt)
	optionmenu:update(dt)
	menu1:update(dt)
	gameovermenu:update(dt)
	if gamestate == "menu" then
		gameloop:stop()
		if game.music then
			menuloop:play()
		end
		if not game.music then
			menuloop:stop()
		end
	elseif gamestate == "game" then
		entity.update(dt)
		player.move(dt)
		cloud.x = cloud.x + 50 * dt
		if cloud.x >= love.window.getWidth() + 90 then
			cloud.x = -90
		end
		if game.fakescore == 10 then
			entity.new("enemy")
			entity.new("life")
			entity.new("boost")
			game.fakescore = game.fakescore + 1
		elseif (game.fakescore - 10) % 15 == 0 and game.fakescore >= 15 then --Make it a little bit more hardcore
			entity.new("enemy")
			game.fakescore = game.fakescore + 1
		end
		if player.life == 0 then
			gamestate = "gameover" 
		end
	elseif gamestate == "gameover" then
		player.life = 3
		game.score = 0
		game.fakescore = 0
	elseif gamestate == "options" then
		if game.music then
			menuloop:play()
		end
		if not game.music then
			menuloop:stop()
		end
	end
end
	
game.input = function(k)
	if gamestate == "menu" then
		menu1:keypressed(k)
	elseif gamestate == "options" then
		optionmenu:keypressed(k)
	elseif gamestate == "gameover" then
		gameovermenu:keypressed(k)
	end
end
	
checkCollision = function(x1,y1,w1,h1, x2,y2,w2,h2)
	return x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1
end